var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function onawait(action) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield action;
                const isAsyncResponse = response.response !== undefined || response.error !== undefined;
                const asyncResponse = isAsyncResponse ? response : { response };
                return resolve(asyncResponse);
            }
            catch (error) {
                const isAsyncError = error.error !== undefined || error.error !== undefined;
                const asyncError = isAsyncError ? error : { error };
                return resolve(asyncError);
            }
        }));
    }
    exports.onawait = onawait;
    exports.default = onawait;
});
